//********************************************************************
//*-------------------------------------------------------------------
//* Sample Source
//*
//* 5724-A18
//*
//* (c) Copyright IBM Corp. 2000, 2002
//*
//* The source code for this program is not published or otherwise
//* divested of its trade secrets, irrespective of what has been
//* deposited with the US Copyright Office.
//*-------------------------------------------------------------------
//*
////////////////////////////////////////////////////////////////////////////////

import com.ibm.commerce.exception.*;
import com.ibm.commerce.order.calculation.*;
import com.ibm.commerce.order.utils.OrderConstants;
import com.ibm.commerce.ras.*;
import java.math.*;
import java.util.*;
/**
 * This is the implementation of the {@link ApplyCalculationUsageCmd
 * ApplyCalculationUsage} command referenced by the
 * <i>ShippingChargeByCarrier</i> shipping charge policy.
 *
 * @see ApplyCalculationUsageCmd
 */
public class ApplyShippingChargeByCarrierCmdImpl extends CalculationCmdImpl implements ApplyCalculationUsageCmd {
	public static final String		COPYRIGHT			= com.ibm.commerce.copyright.IBMCopyright.SHORT_COPYRIGHT;
	private static final BigDecimal	BIG_DECIMAL_ZERO	= new BigDecimal(0);
	private Item[] iItems = null;
public ApplyShippingChargeByCarrierCmdImpl() {
	super();
}
public void checkAppliedItems() throws ECException {}
public Set getAppliedItems() {
	HashSet hshItems = new HashSet();
	for(int i = 0; i < iItems.length; i++) hshItems.add(iItems[i]);
	return hshItems;
}
	public void performExecute() throws ECException {
		
		final String strMethod = "performExecute";
		ECTrace.entry(ECTraceIdentifiers.COMPONENT_ORDER, getClass().getName(), strMethod);
		
		for(int i = 0; i < iItems.length; i++) {
			
			int nPrepareFlags = iItems[i].getPrepareFlags().intValue();
			nPrepareFlags |= OrderConstants.PREPAREFLAGS_SHIPPING_CHARGE_BY_CARRIER;
			
			iItems[i].setPrepareFlags(new Integer(nPrepareFlags));
			iItems[i].setShippingTotal(BIG_DECIMAL_ZERO);
			
			iItems[i].commit();
			
		}
		
		ECTrace.exit(ECTraceIdentifiers.COMPONENT_ORDER, getClass().getName(), strMethod);
		
	}
public void setItems(Item[] aItems) { iItems = aItems; }
public void setTaxCategoryIds(Integer[] anTaxCategoryIds) {}
}
