//********************************************************************
//*-------------------------------------------------------------------
//* Sample Source
//*
//* 5724-A18
//*
//* (c) Copyright IBM Corp. 2000, 2002
//*
//* The source code for this program is not published or otherwise
//* divested of its trade secrets, irrespective of what has been
//* deposited with the US Copyright Office.
//*-------------------------------------------------------------------
//*
////////////////////////////////////////////////////////////////////////////////

import com.ibm.commerce.usermanagement.commands.*;

import java.util.*;
import com.ibm.commerce.ras.*;
import com.ibm.commerce.exception.*;
import com.ibm.commerce.server.*;
import com.ibm.commerce.common.objects.*; 
import com.ibm.commerce.command.*;
import com.ibm.commerce.server.*;
import com.ibm.commerce.datatype.*;
import com.ibm.commerce.user.objects.*;
import com.ibm.commerce.member.helpers.*;
/**
 * The implementation class for SetBusinessEntityCmd.
 */
public class SetBusinessEntityCmdImpl extends TaskCommandImpl implements SetBusinessEntityCmd
{
	public static final String COPYRIGHT = com.ibm.commerce.copyright.IBMCopyright.SHORT_COPYRIGHT;
	public final static String CLASSNAME = "com.ibm.commerce.usermanagement.commands.SetBusinessEntityCmdImpl";

	protected TypedProperty requestProperties = null;

public TypedProperty getRequestProperties()
{
	return requestProperties;
}
public void performExecute() throws ECException
{
	final String METHODNAME = "performExecute";
	TypedProperty hshNVPs = new TypedProperty();	
	ECTrace.entry(ECTraceIdentifiers.COMPONENT_USER, CLASSNAME, METHODNAME);
	if (requestProperties == null)
	{
		ECTrace.trace(ECTraceIdentifiers.COMPONENT_USER, CLASSNAME, METHODNAME, 
						"requestProperties is not set");	
		return;
	}
	String strParentMemberId = requestProperties.getString(ECUserConstants.EC_PARENTMEMBERID, null);
	if (strParentMemberId == null)
	{
		throw new ECApplicationException(ECMessage._ERR_CMD_MISSING_PARAM, CLASSNAME, METHODNAME,
							ECMessageHelper.generateMsgParms(ECUserConstants.EC_PARENTMEMBERID),
							ECUserConstants.EC_CMD_ORGENTITY_ERR_VIEWNAME);
	}
	// Remove BusinessEntity parameter is there is any.
	for (Enumeration enuProperty = requestProperties.keys() ; enuProperty.hasMoreElements() ;)
	{
		String strPropertyName = (String)enuProperty.nextElement();
		if (strPropertyName != null && strPropertyName.indexOf(ECUserConstants.EC_ORG_BUSINESSENTITY) > -1)
		{
			requestProperties.remove(strPropertyName);
		}
	}
	if (strParentMemberId.equals(ECMemberConstants.EC_DB_ROOT_ORGANIZATION_ID))
	{
		requestProperties.put(ECUserConstants.EC_ORG_BUSINESSENTITY + "_null", ECUserConstants.EC_ORG_BUSINESSENTITY_YES);
	}
	else
	{
		requestProperties.put(ECUserConstants.EC_ORG_BUSINESSENTITY + "_null", ECUserConstants.EC_ORG_BUSINESSENTITY_NO);		
	}
		
	ECTrace.exit(ECTraceIdentifiers.COMPONENT_USER, CLASSNAME, METHODNAME);	
}
public void setRequestProperties(TypedProperty aRequestProperties)
{
	requestProperties = aRequestProperties;
}
}
